# Record Class LLServerConfiguration

java.lang.Object
java.lang.Record
com.io7m.looseleaf.server.api.LLServerConfiguration

Record Components:
  `schema` - The schema identifier
  `addresses` - The server bind addresses
  `databaseFile` - The server's database file
  `databaseKind` - The server's database kind (such as "SQLITE")
  `roles` - The set of user roles
  `users` - The set of users
  `telemetry` - The telemetry configuration
  `faultInjection` - The fault injection configuration

public record LLServerConfiguration(String schema, List<LLServerAddress> addresses, Path databaseFile, Optional<String> databaseKind, List<LLServerRole> roles, List<LLServerUser> users, Optional<LLTelemetryConfiguration> telemetry, Optional<LLFaultInjection> faultInjection) extends Record
A server configuration.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LLServerConfiguration(String schema, List<LLServerAddress> addresses, Path databaseFile, Optional<String> databaseKind, List<LLServerRole> roles, List<LLServerUser> users, Optional<LLTelemetryConfiguration> telemetry, Optional<LLFaultInjection> faultInjection)`
  A server configuration.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `List<LLServerAddress>`
  `addresses()`
  Returns the value of the `addresses` record component.
  `Path`
  `databaseFile()`
  Returns the value of the `databaseFile` record component.
  `Optional<String>`
  `databaseKind()`
  Returns the value of the `databaseKind` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `Optional<LLFaultInjection>`
  `faultInjection()`
  Returns the value of the `faultInjection` record component.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `List<LLServerRole>`
  `roles()`
  Returns the value of the `roles` record component.
  `String`
  `schema()`
  Returns the value of the `schema` record component.
  `Optional<LLTelemetryConfiguration>`
  `telemetry()`
  Returns the value of the `telemetry` record component.
  `LLSecurityContext`
  `toSecurityContext()`
  `final String`
  `toString()`
  Returns a string representation of this record class.
  `List<LLServerUser>`
  `users()`
  Returns the value of the `users` record component.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### LLServerConfiguration

    public LLServerConfiguration(String schema, List<LLServerAddress> addresses, Path databaseFile, Optional<String> databaseKind, List<LLServerRole> roles, List<LLServerUser> users, Optional<LLTelemetryConfiguration> telemetry, Optional<LLFaultInjection> faultInjection)
    A server configuration.
    Parameters:
      `schema` - The schema identifier
      `addresses` - The server bind addresses
      `databaseFile` - The server's database file
      `databaseKind` - The server's database kind (such as "SQLITE")
      `roles` - The set of user roles
      `users` - The set of users
      `telemetry` - The telemetry configuration
      `faultInjection` - The fault injection configuration

- ## Method Details

  - ### toSecurityContext

    public LLSecurityContext toSecurityContext()
    Returns:
      The configuration as a security context

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### schema

    public String schema()
    Returns the value of the `schema` record component.
    Returns:
      the value of the `schema` record component

  - ### addresses

    public List<LLServerAddress> addresses()
    Returns the value of the `addresses` record component.
    Returns:
      the value of the `addresses` record component

  - ### databaseFile

    public Path databaseFile()
    Returns the value of the `databaseFile` record component.
    Returns:
      the value of the `databaseFile` record component

  - ### databaseKind

    public Optional<String> databaseKind()
    Returns the value of the `databaseKind` record component.
    Returns:
      the value of the `databaseKind` record component

  - ### roles

    public List<LLServerRole> roles()
    Returns the value of the `roles` record component.
    Returns:
      the value of the `roles` record component

  - ### users

    public List<LLServerUser> users()
    Returns the value of the `users` record component.
    Returns:
      the value of the `users` record component

  - ### telemetry

    public Optional<LLTelemetryConfiguration> telemetry()
    Returns the value of the `telemetry` record component.
    Returns:
      the value of the `telemetry` record component

  - ### faultInjection

    public Optional<LLFaultInjection> faultInjection()
    Returns the value of the `faultInjection` record component.
    Returns:
      the value of the `faultInjection` record component